'use strict';

// Generated by CoffeeScript 2.0.0
var DEFAULTS,
    SKIP,
    commonReducer,
    createActions,
    createReducer,
    identity,
    initialReducer,
    isFunction,
    toSnakeCase,
    _wrapCreator,
    _extends = Object.assign || function (target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i];for (var key in source) {
      if (Object.prototype.hasOwnProperty.call(source, key)) {
        target[key] = source[key];
      }
    }
  }return target;
};

SKIP = {};

DEFAULTS = {
  JOIN: '/'
};

identity = function identity(payload) {
  return payload;
};

isFunction = function isFunction(v) {
  return typeof v === 'function';
};

toSnakeCase = function toSnakeCase(s) {
  var c, i, len, upperCharts;
  s = s.toString();
  upperCharts = s.match(/[A-Z]/g);
  if (!upperCharts) {
    return s;
  }
  for (i = 0, len = upperCharts.length; i < len; i++) {
    c = upperCharts[i];
    s = s.replace(new RegExp('' + c), '_' + c.toLowerCase());
  }
  if (s[0] === '_') {
    return s.slice(1);
  } else {
    return s;
  }
};

// Wrap results into actions with types and payloads
_wrapCreator = function wrapCreator(type, creator) {
  return function () {
    var action, m;
    action = creator.apply(undefined, arguments);
    if (!action) {
      return { type: type };
    }
    // If creator return SKIP do nothing more
    if (action === SKIP) {
      return;
    }
    // Support redux-thunk middleware
    if (isFunction(action)) {
      m = _wrapCreator(type, action);
      return function (dispatch, getState) {
        return dispatch(m(dispatch, getState));
      };
    }
    // Support promises (requires redux-thunk)
    if (isFunction(action.then)) {
      m = _wrapCreator(type, identity);
      return function (dispatch) {
        return action.then(function (a) {
          return dispatch(m(a));
        });
      };
    }
    if (!action.type) {
      action = {
        type: type,
        payload: action
      };
    }
    return action;
  };
};

commonReducer = function commonReducer(TYPES, DEFAULT) {
  var reducers;
  reducers = {};
  reducers[TYPES.UPDATE || 'UPDATE'] = function (state, action) {
    return _extends({}, state, action.payload);
  };
  reducers[TYPES.RESET || 'RESET'] = function (state, action) {
    return DEFAULT;
  };
  return reducers;
};

initialReducer = function initialReducer(TYPES) {
  var reducers;
  reducers = {};
  reducers[TYPES.INIT || 'INIT'] = function (state, action) {
    return _extends({}, state, {
      inited: true
    });
  };
  return reducers;
};

createReducer = function createReducer() {
  var DEFAULT = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

  var i, len, mixin, reducers;
  reducers = {};

  for (var _len = arguments.length, mixins = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    mixins[_key - 1] = arguments[_key];
  }

  for (i = 0, len = mixins.length; i < len; i++) {
    mixin = mixins[i];
    reducers = _extends({}, reducers, mixin);
  }
  return function () {
    var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : DEFAULT;
    var action = arguments[1];

    var reducer;
    reducer = reducers[action.type];
    if (reducer) {
      return reducer(state, action);
    } else {
      return state;
    }
  };
};

createActions = function createActions(prefix) {
  var actionCreator, actionType, created, creator, i, len, name, type;
  created = {
    TYPES: {}
  };

  for (var _len2 = arguments.length, creators = Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
    creators[_key2 - 1] = arguments[_key2];
  }

  for (i = 0, len = creators.length; i < len; i++) {
    creator = creators[i];
    for (name in creator) {
      actionCreator = creator[name];
      actionType = type = toSnakeCase(name).toUpperCase();
      if (prefix) {
        actionType = '' + prefix + DEFAULTS.JOIN + actionType;
      }
      if (!isFunction(actionCreator)) {
        actionCreator = identity;
      }
      actionCreator = _wrapCreator(actionType, actionCreator.bind(created));
      created.TYPES[type] = actionType;
      created[name] = actionCreator;
    }
  }
  return created;
};

module.exports = { SKIP: SKIP, DEFAULTS: DEFAULTS, createActions: createActions, createReducer: createReducer, commonReducer: commonReducer, initialReducer: initialReducer };